# coding: utf-8
import time
import logging

from celery import Celery, task

from django.core.exceptions import ImproperlyConfigured
from django.conf import settings
from jobtastic import JobtasticTask
from jmb.async.models import Task

logger = logging.getLogger('celery.task')

class JmbJobtasticTask(JobtasticTask):
    @classmethod
    def delay_or_fail(self, *args, **kwargs):
        obj =  super(JmbJobtasticTask, self).delay_or_fail(*args, **kwargs)
        task_id = obj.task_id
        task_name = self.task_name 
        status = obj.status
        jtask = Task(title=task_name, task_id=task_id, status=status, note=task_name)
        jtask.save()
        return jtask
        
class AspettaTask(JmbJobtasticTask):
    task_name = "NOME DEL TASK"
    significant_kwargs = []
    herd_avoidance_timeout = 60 
    cache_duration = 0 
    def calculate_result(self, **kw):
        logger.info('Running aspetta con xtastic ')
        
        n_of_steps = 20
        sec_for_step = 2
        # Only actually update the progress in the backend every n operations
        update_frequency = 1
        total_delay = 40

        for count, x in enumerate(range(0, total_delay, sec_for_step)):
            time.sleep(sec_for_step)
            self.update_progress(
                count,
                n_of_steps,
                update_frequency=update_frequency,
            )
            logger.info('Running aspetta - %s' % x)
        return "Finito!" 
